﻿<AML>
 <Item type="Method" id="3C242A8AF18849D2911D957FD7870C9F" action="add">
  <execution_allowed_to keyed_name="World" type="Identity">A73B655731924CD0B027E4F4D5FCC0A9</execution_allowed_to>
  <method_code><![CDATA[/* *****************************************************************************
Method Name:			acc_tax_type_change
Created By		:		SolidCAD 
Creation Date:			2018-01-23
Description:
	IF tax type is "SR" and "",auto set "7.00" to GST Percent rate,Visible GST Percent and auto bind Company's Default Purchase and Sale Tax.
	IF tax type is "ZR",set "0.00" to GST Percent rate,Visible GST Percent and set "" to Tax Type.
	IF tax type is "OSS",auto bind Company's Default Purchase and Sale Tax.
	
Hooks:
	Type:	Form	:	sop_sale_invoice
	Event:	acc_tax_type ( onChange )
	
	Type:	Form	:	sop_commercial_invoice
	Event:	acc_tax_type ( onChange )
	
	Type:	Form	:	sop_sale_order_Service
	Event:	acc_tax_type ( onChange )
	
	Type:	Form	:	sop_sale_order_Equipment
	Event:	acc_tax_type ( onChange )
	
	Type:	Form	:	sop_po_out
	Event:	acc_tax_type ( onChange )
	
	Type:	Form	:	sop_po_out
	Event:	Form Load ( onLoad )
	
Revisions:
	Rev Date		Modified By			Description
	YYYY-MM-DD		$username$			Initial creation
***************************************************************************** */
//debugger;
var myInnovator = new Innovator();

function getInputByName(inputName) {
    var allFields = document.getElementsByName(inputName);
    var requiredField;
    for (var i = 0; i < allFields.length; i++) {
        if (allFields[i].tagName.toUpperCase() == "INPUT") {
            requiredField = allFields[i];
        }
    }
    return requiredField;
}

var id = top.aras.getItemProperty(document.item, 'id');
var acc_tax_type = "";
var div_id = getFieldByName("acc_tax_type").id;
var control_id = div_id.substring(0, div_id.indexOf("span"));
var select = document.getElementById(control_id);
var selected_index = select.selectedIndex;
if (selected_index >= 0) {
    acc_tax_type = select.options[selected_index].text;
}


var itemType = document.thisItem.getType().toString().toLowerCase();
var gst_percent_field = getFieldByName("pop_gst_percent");

if (acc_tax_type === "SR") {

    var tax_item = myInnovator.newItem("acc_taxtemplate", "get");

    if (itemType === "sop_sale_invoice" || itemType === "sop_commercial_invoice " || itemType === "sop_sale_order" || itemType === "sop_po_out") {
        tax_item.setProperty("acc_taxinuse", "Sale");
    } else {
        tax_item.setProperty("acc_taxinuse", "Purchase");
    }
    tax_item.setPropertyCondition("acc_taxinuse", "eq");
    tax_item.setProperty("acc_isdefault", 1);
    tax_item.setPropertyCondition("acc_isdefault", "eq");
    var tax_result = tax_item.apply();

    var tax_count = tax_result.getItemCount();
    if (tax_count > 0) {
        var tax = tax_result.getItemByIndex(0);
        var d_gst_percent = parseFloat(tax.getProperty("acc_rate", ""));
        handleItemChange("pop_gst_percent", d_gst_percent);
    }
    if (gst_percent_field) {
        gst_percent_field.disabled = false;
        gst_percent_field.readOnly = false;
        gst_percent_field.style.visibility = "visible";
        gst_percent_field.style.display = "";
    }

    var erp_company_setup = myInnovator.newItem("erp_company_setup", "get");
    var result = erp_company_setup.apply();
    var result_count = result.getItemCount();
    if (result_count > 0) {
        var setup = result.getItemByIndex(0);
        var erp_basic_purchase_tax = setup.getProperty("erp_basic_purchase_tax", "");
        var erp_basic_sale_tax = setup.getProperty("erp_basic_sale_tax", "");
        var itemType = document.thisItem.getType().toString().toLowerCase();
        switch (itemType) {
            case 'sop_sale_invoice':
                {
                    handleItemChange("acc_tax", erp_basic_sale_tax);
                }
                break;

            case 'sop_commercial_invoice ':
                {
                    handleItemChange("acc_tax", erp_basic_sale_tax);
                }
                break;
            default:
                // do nothing
        }
    }
}

if (acc_tax_type === "") {

    var tax_item = myInnovator.newItem("acc_taxtemplate", "get");

    if (itemType === "sop_sale_invoice" || itemType === "sop_commercial_invoice " || itemType === "sop_sale_order" || itemType === "sop_po_out") {
        tax_item.setProperty("acc_taxinuse", "Sale");
    } else {
        tax_item.setProperty("acc_taxinuse", "Purchase");
    }
    tax_item.setPropertyCondition("acc_taxinuse", "eq");
    tax_item.setProperty("acc_isdefault", 1);
    tax_item.setPropertyCondition("acc_isdefault", "eq");
    var tax_result = tax_item.apply();

    var tax_count = tax_result.getItemCount();
    if (tax_count > 0) {
        var tax = tax_result.getItemByIndex(0);
        var d_gst_percent = parseFloat(tax.getProperty("acc_rate", ""));
        handleItemChange("pop_gst_percent", d_gst_percent);
    }

    if (gst_percent_field) {
        gst_percent_field.disabled = false;
        gst_percent_field.readOnly = false;
        gst_percent_field.style.visibility = "visible";
        gst_percent_field.style.display = "";
    }

    var erp_company_setup = myInnovator.newItem("erp_company_setup", "get");
    var result = erp_company_setup.apply();
    var result_count = result.getItemCount();
    if (result_count > 0) {
        var setup = result.getItemByIndex(0);
        var erp_basic_purchase_tax = setup.getProperty("erp_basic_purchase_tax", "");
        var erp_basic_sale_tax = setup.getProperty("erp_basic_sale_tax", "");
        var itemType = document.thisItem.getType().toString().toLowerCase();
        switch (itemType) {
            case 'sop_sale_invoice':
                {
                    handleItemChange("acc_tax", erp_basic_sale_tax);
                }
                break;

            case 'sop_commercial_invoice ':
                {
                    handleItemChange("acc_tax", erp_basic_sale_tax);
                }
                break;
            default:
                // do nothing
        }

    }
}
if (acc_tax_type === "ZR" || acc_tax_type === "OSS") {

    handleItemChange("pop_gst_percent", 0);

    if (gst_percent_field) {
        gst_percent_field.disabled = false;
        gst_percent_field.readOnly = false;
        gst_percent_field.style.visibility = "visible";
        gst_percent_field.style.display = "";
    }
}

if (acc_tax_type === "ZR") {

    handleItemChange("acc_tax", "");
}
if (acc_tax_type === "OSS") {

    var erp_company_setup = myInnovator.newItem("erp_company_setup", "get");
    var result = erp_company_setup.apply();
    var result_count = result.getItemCount();
    if (result_count > 0) {
        var setup = result.getItemByIndex(0);
        var erp_basic_purchase_tax = setup.getProperty("erp_basic_purchase_tax", "");
        var erp_basic_sale_tax = setup.getProperty("erp_basic_sale_tax", "");
        var itemType = document.thisItem.getType().toString().toLowerCase();
        switch (itemType) {
            case 'sop_sale_invoice':
                {
                    handleItemChange("acc_tax", erp_basic_sale_tax);
                }
                break;

            case 'sop_commercial_invoice ':
                {
                    handleItemChange("acc_tax", erp_basic_sale_tax);
                }
                break;
            default:
                // do nothing
        }
    }
}

return this;]]></method_code>
  <method_type>JavaScript</method_type>
  <name>acc_tax_type_change</name>
 </Item>
</AML>